// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

#include <stdint.h>

#ifdef _MSC_VER
#define DLLEXPORT __declspec(dllexport)
#else
#define DLLEXPORT __attribute__((visibility("default")))
#endif

struct DotNetRuntimeContractDescriptor
{
    uint64_t magic;
    uint32_t flags;
    const uint32_t descriptor_size;
    const char *descriptor;
    const uint32_t pointer_data_count;
    uint32_t pad0;
    const uintptr_t *pointer_data;
};

extern const uintptr_t contractDescriptorPointerData[];

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor;

DLLEXPORT struct DotNetRuntimeContractDescriptor DotNetRuntimeContractDescriptor = {
    .magic = 0x0043414443434e44ull, // "DNCCDAC\0"
    .flags = 0x00000001,
    .descriptor_size = 9063,
    .descriptor = "{\"version\":0,\"baseline\":\"empty\",\"types\":{\"Thread\":{\"Id\":16,\"OSId\":336,\"State\":0,\"PreemptiveGCDisabled\":4,\"RuntimeThreadLocals\":32,\"Frame\":8,\"ExceptionTracker\":392,\"GCHandle\":[344,\"GCHandle\"],\"LastThrownObject\":[376,\"GCHandle\"],\"LinkNext\":[152,\"pointer\"]},\"ThreadStore\":{\"FirstThreadLink\":88,\"ThreadCount\":112,\"UnstartedCount\":116,\"BackgroundCount\":120,\"PendingCount\":124,\"DeadCount\":128},\"RuntimeThreadLocals\":{\"AllocContext\":0},\"EEAllocContext\":{\"GCAllocationContext\":8},\"GCAllocContext\":{\"Pointer\":0,\"Limit\":8},\"Exception\":{\"_message\":16,\"_innerException\":32,\"_stackTrace\":48,\"_watsonBuckets\":56,\"_stackTraceString\":64,\"_remoteStackTraceString\":72,\"_HResult\":108,\"_xcode\":104},\"ExceptionInfo\":{\"ThrownObject\":8,\"PreviousNestedInfo\":0},\"GCHandle\":{\"!\":8},\"Object\":{\"m_pMethTab\":0},\"String\":{\"m_FirstChar\":12,\"m_StringLength\":8},\"Array\":{\"!\":16,\"m_NumComponents\":8},\"InteropSyncBlockInfo\":{},\"SyncBlock\":{\"InteropInfo\":56},\"SyncTableEntry\":{\"!\":16,\"SyncBlock\":0},\"Module\":{\"Assembly\":248,\"PEAssembly\":216,\"Base\":224,\"Flags\":232,\"LoaderAllocator\":176,\"DynamicMetadata\":840,\"Path\":200,\"FileName\":208,\"ReadyToRunInfo\":704,\"GrowableSymbolStream\":408,\"FieldDefToDescMap\":512,\"ManifestModuleReferencesMap\":40,\"MemberRefToDescMap\":72,\"MethodDefToDescMap\":448,\"TypeDefToMethodTableMap\":416,\"TypeRefToMethodTableMap\":8,\"MethodDefToILCodeVersioningStateMap\":480},\"ModuleLookupMap\":{\"TableData\":8,\"Next\":0,\"Count\":16,\"SupportedFlagsMask\":24},\"Assembly\":{\"IsCollectible\":48,\"Module\":16,\"Error\":64,\"NotifyFlags\":56,\"Level\":52},\"LoaderAllocator\":{\"ReferenceCount\":1840},\"PEAssembly\":{\"PEImage\":8},\"PEImage\":{\"LoadedImageLayout\":128,\"ProbeExtensionResult\":40},\"PEImageLayout\":{\"Base\":8,\"Size\":16,\"Flags\":20},\"CGrowableSymbolStream\":{\"Buffer\":8,\"Size\":16},\"ProbeExtensionResult\":{\"Type\":0},\"AppDomain\":{\"RootAssembly\":1088,\"DomainAssemblyList\":576},\"ArrayListBase\":{\"Count\":0,\"FirstBlock\":8},\"ArrayListBlock\":{\"Next\":0,\"Size\":8,\"ArrayStart\":16},\"MethodTable\":{\"!\":64,\"MTFlags\":0,\"BaseSize\":4,\"MTFlags2\":8,\"EEClassOrCanonMT\":40,\"Module\":24,\"ParentMethodTable\":16,\"NumInterfaces\":14,\"NumVirtuals\":12,\"PerInstInfo\":48,\"AuxiliaryData\":32},\"MethodTableAuxiliaryData\":{\"LoaderModule\":8,\"OffsetToNonVirtualSlots\":2},\"EEClass\":{\"MethodTable\":16,\"NumMethods\":52,\"CorTypeAttr\":40,\"InternalCorElementType\":48,\"NumNonVirtualSlots\":62},\"ArrayClass\":{\"Rank\":72},\"GenericsDictInfo\":{\"NumDicts\":4,\"NumTypeArgs\":6},\"TypeDesc\":{\"TypeAndFlags\":0},\"ParamTypeDesc\":{\"TypeArg\":16},\"TypeVarTypeDesc\":{\"Module\":16,\"Token\":40},\"FnPtrTypeDesc\":{\"NumArgs\":24,\"CallConv\":28,\"RetAndArgTypes\":32,\"LoaderModule\":16},\"DynamicMetadata\":{\"Size\":0,\"Data\":4},\"StressLog\":{\"!\":176,\"LoggedFacilities\":0,\"Level\":4,\"MaxSizePerThread\":8,\"MaxSizeTotal\":12,\"TotalChunks\":16,\"Logs\":24,\"TickFrequency\":48,\"StartTimestamp\":56,\"ModuleOffset\":72},\"StressLogModuleDesc\":{\"!\":16,\"BaseAddress\":[0,\"pointer\"],\"Size\":[8,\"nuint\"]},\"ThreadStressLog\":{\"Next\":0,\"ThreadId\":[8,\"uint64\"],\"WriteHasWrapped\":[18,\"uint8\"],\"CurrentPtr\":[24,\"pointer\"],\"ChunkListHead\":40,\"ChunkListTail\":48,\"CurrentWriteChunk\":64},\"StressLogChunk\":{\"!\":32792,\"Prev\":0,\"Next\":8,\"Buf\":16,\"Sig1\":32784,\"Sig2\":32788},\"StressMsgHeader\":{\"!\":16},\"StressMsg\":{\"Header\":[0,\"StressMsgHeader\"],\"Args\":16},\"MethodDesc\":{\"!\":16,\"ChunkIndex\":2,\"Slot\":4,\"Flags\":6,\"Flags3AndTokenRemainder\":0,\"EntryPointFlags\":3,\"CodeData\":8},\"MethodDescChunk\":{\"!\":24,\"MethodTable\":0,\"Next\":8,\"Size\":16,\"Count\":17,\"FlagsAndTokenRange\":18},\"NonVtableSlot\":{\"!\":8},\"MethodImpl\":{\"!\":16},\"NativeCodeSlot\":{\"!\":8},\"InstantiatedMethodDesc\":{\"!\":40,\"PerInstInfo\":24,\"Flags2\":32,\"NumGenericArgs\":34},\"StoredSigMethodDesc\":{\"Sig\":16,\"cSig\":24,\"ExtendedFlags\":28},\"DynamicMethodDesc\":{\"!\":48,\"MethodName\":32},\"ArrayMethodDesc\":{\"!\":32},\"FCallMethodDesc\":{\"!\":24},\"PInvokeMethodDesc\":{\"!\":56},\"EEImplMethodDesc\":{\"!\":32},\"CodePointer\":{\"!\":8},\"MethodDescCodeData\":{\"TemporaryEntryPoint\":8,\"VersioningState\":0},\"MethodDescVersioningState\":{\"NativeCodeVersionNode\":16,\"Flags\":8},\"PrecodeMachineDescriptor\":{\"ReadWidthOfPrecodeType\":5,\"ShiftOfPrecodeType\":6,\"OffsetOfPrecodeType\":4,\"InvalidPrecodeType\":7,\"StubPrecodeType\":8,\"PInvokeImportPrecodeType\":9,\"FixupPrecodeType\":10,\"ThisPointerRetBufPrecodeType\":11,\"StubCodePageSize\":0},\"PlatformMetadata\":{\"PrecodeMachineDescriptor\":0,\"CodePointerFlags\":12},\"StubPrecodeData\":{\"SecretParam\":0,\"Type\":16},\"ThisPtrRetBufPrecodeData\":{\"MethodDesc\":8},\"FixupPrecodeData\":{\"MethodDesc\":8},\"ReadyToRunInfo\":{\"CompositeInfo\":40,\"NumRuntimeFunctions\":88,\"RuntimeFunctions\":80,\"NumHotColdMap\":104,\"HotColdMap\":96,\"DelayLoadMethodCallThunks\":112,\"EntryPointToMethodDescMap\":360},\"ImageDataDirectory\":{\"!\":8,\"VirtualAddress\":0,\"Size\":4},\"RuntimeFunction\":{\"!\":8,\"BeginAddress\":0,\"UnwindData\":4},\"UnwindInfo\":{},\"HashMap\":{\"Buckets\":16},\"Bucket\":{\"!\":64,\"Keys\":0,\"Values\":32},\"RangeSectionMap\":{\"TopLevelData\":0},\"RangeSectionFragment\":{\"RangeBegin\":8,\"RangeEndOpen\":16,\"RangeSection\":24,\"Next\":0},\"RangeSection\":{\"RangeBegin\":0,\"RangeEndOpen\":8,\"NextForDelete\":56,\"JitManager\":24,\"Flags\":16,\"HeapList\":40,\"R2RModule\":32},\"RealCodeHeader\":{\"MethodDesc\":24,\"NumUnwindInfos\":32,\"UnwindInfos\":36},\"CodeHeapListNode\":{\"Next\":0,\"StartAddress\":16,\"EndAddress\":24,\"MapBase\":32,\"HeaderMap\":40},\"ILCodeVersioningState\":{\"FirstVersionNode\":24,\"ActiveVersionKind\":0,\"ActiveVersionNode\":8,\"ActiveVersionModule\":8,\"ActiveVersionMethodDef\":16},\"NativeCodeVersionNode\":{\"Next\":24,\"MethodDesc\":8,\"NativeCode\":0,\"Flags\":52,\"ILVersionId\":16},\"ILCodeVersionNode\":{\"VersionId\":16,\"Next\":24,\"RejitState\":32},\"ProfControlBlock\":{\"GlobalEventMask\":1888},\"Frame\":{\"Next\":8},\"InlinedCallFrame\":{\"!\":56,\"CallSiteSP\":24,\"CallerReturnAddress\":32,\"CalleeSavedFP\":40},\"SoftwareExceptionFrame\":{\"!\":1184,\"TargetContext\":192,\"ReturnAddress\":16},\"FramedMethodFrame\":{\"!\":32,\"TransitionBlockPtr\":16},\"TransitionBlock\":{\"!\":176,\"ReturnAddress\":8,\"CalleeSavedRegisters\":0},\"FuncEvalFrame\":{\"!\":40,\"DebuggerEvalPtr\":24},\"DebuggerEval\":{\"!\":1200,\"TargetContext\":0,\"EvalDuringException\":1166},\"ResumableFrame\":{\"!\":24,\"TargetContextPtr\":16},\"HijackFrame\":{\"!\":40,\"ReturnAddress\":16,\"HijackArgsPtr\":32},\"HijackArgs\":{\"!\":192,\"X0\":96,\"X1\":104,\"X19\":16,\"X20\":24,\"X21\":32,\"X22\":40,\"X23\":48,\"X24\":56,\"X25\":64,\"X26\":72,\"X27\":80,\"X28\":88,\"Fp\":0,\"Lr\":8},\"FaultingExceptionFrame\":{\"!\":1024,\"TargetContext\":32},\"CalleeSavedRegisters\":{\"!\":96,\"X19\":16,\"X20\":24,\"X21\":32,\"X22\":40,\"X23\":48,\"X24\":56,\"X25\":64,\"X26\":72,\"X27\":80,\"X28\":88,\"Fp\":0,\"Lr\":8}},\"globals\":{\"InlinedCallFrameIdentifier\":[\"0x1\",\"nuint\"],\"ResumableFrameIdentifier\":[\"0x2\",\"nuint\"],\"RedirectedThreadFrameIdentifier\":[\"0x3\",\"nuint\"],\"FaultingExceptionFrameIdentifier\":[\"0x4\",\"nuint\"],\"SoftwareExceptionFrameIdentifier\":[\"0x5\",\"nuint\"],\"FuncEvalFrameIdentifier\":[\"0x6\",\"nuint\"],\"PInvokeCalliFrameIdentifier\":[\"0x7\",\"nuint\"],\"HijackFrameIdentifier\":[\"0x8\",\"nuint\"],\"PrestubMethodFrameIdentifier\":[\"0x9\",\"nuint\"],\"CallCountingHelperFrameIdentifier\":[\"0xa\",\"nuint\"],\"StubDispatchFrameIdentifier\":[\"0xb\",\"nuint\"],\"ExternalMethodFrameIdentifier\":[\"0xc\",\"nuint\"],\"DynamicHelperFrameIdentifier\":[\"0xd\",\"nuint\"],\"ProtectValueClassFrameIdentifier\":[\"0xe\",\"nuint\"],\"DebuggerClassInitMarkFrameIdentifier\":[\"0xf\",\"nuint\"],\"DebuggerExitFrameIdentifier\":[\"0x10\",\"nuint\"],\"DebuggerU2MCatchHandlerFrameIdentifier\":[\"0x11\",\"nuint\"],\"ExceptionFilterFrameIdentifier\":[\"0x12\",\"nuint\"],\"MethodDescTokenRemainderBitCount\":[\"0xc\",\"uint8\"],\"FeatureEHFunclets\":[\"0x1\",\"uint8\"],\"FeatureCOMInterop\":[\"0x0\",\"uint8\"],\"ObjectToMethodTableUnmask\":[\"0x7\",\"uint8\"],\"SOSBreakingChangeVersion\":[\"0x5\",\"uint8\"],\"DirectorySeparator\":[\"0x2f\",\"uint8\"],\"HashMapSlotsPerBucket\":[\"0x4\",\"uint32\"],\"HashMapValueMask\":[\"0x7fffffffffffffff\",\"uint64\"],\"MethodDescAlignment\":[\"0x8\",\"uint64\"],\"ObjectHeaderSize\":[\"0x8\",\"uint64\"],\"SyncBlockValueToObjectOffset\":[\"0x4\",\"uint16\"],\"StubCodeBlockLast\":[\"0xf\",\"uint8\"],\"StressLogEnabled\":[\"0x1\",\"uint8\"],\"StressLogHasModuleTable\":[\"0x1\",\"uint8\"],\"StressLogMaxModules\":[\"0x5\",\"uint64\"],\"StressLogChunkSize\":[\"0x8000\",\"uint32\"],\"StressLogValidChunkSig\":[\"0xcfcfcfcf\",\"uint32\"],\"StressLogMaxMessageSize\":[\"0x208\",\"uint64\"],\"AppDomain\":[[1],\"pointer\"],\"SystemDomain\":[[2],\"pointer\"],\"ThreadStore\":[[3],\"pointer\"],\"FinalizerThread\":[[4],\"pointer\"],\"GCThread\":[[5],\"pointer\"],\"ArrayBoundsZero\":[[6],\"pointer\"],\"ExceptionMethodTable\":[[7],\"pointer\"],\"FreeObjectMethodTable\":[[8],\"pointer\"],\"ObjectMethodTable\":[[9],\"pointer\"],\"ObjectArrayMethodTable\":[[10],\"pointer\"],\"StringMethodTable\":[[11],\"pointer\"],\"SyncTableEntries\":[[12],\"pointer\"],\"MiniMetaDataBuffAddress\":[[13],\"pointer\"],\"MiniMetaDataBuffMaxSize\":[[14],\"pointer\"],\"StressLog\":[[15],\"pointer\"],\"StressLogModuleTable\":[[16],\"pointer\"],\"ExecutionManagerCodeRangeMapAddress\":[[17],\"pointer\"],\"PlatformMetadata\":[[18],\"pointer\"],\"ProfilerControlBlock\":[[19],\"pointer\"],\"OperatingSystem\":[\"1\",\"string\"],\"Architecture\":[\"arm64\",\"string\"],\"RID\":[\"1-arm64\",\"string\"]},\"contracts\":{\"CodeVersions\":1,\"DacStreams\":1,\"EcmaMetadata\":1,\"Exception\":1,\"ExecutionManager\":2,\"Loader\":1,\"Object\":1,\"PlatformMetadata\":1,\"PrecodeStubs\":2,\"ReJIT\":1,\"RuntimeInfo\":1,\"RuntimeTypeSystem\":1,\"StackWalk\":1,\"StressLog\":2,\"Thread\":1}}",
    .pointer_data_count = 20,
    .pointer_data = &contractDescriptorPointerData[0],
};
